
function Create(self)
    self.LTimer = Timer();
    self.BTimer = Timer();

    --print ("ClearEye Says Hello World!");
end

function Lasers(XPos, self)
	local particle = CreateMOPixel("ClearEye Orbital Laser Pulse", "ClearEye.rte");
	particle.Pos.Y = 0;
	particle.Pos.X = XPos;
	particle.Vel.Y = 120;
	particle:SetWhichMOToNotHit(ToMovableObject(self), 999);
	MovableMan:AddParticle(particle);
end

function Update(self)
	self.ToSettle = false;
	
	if math.abs(self.Vel.Y) < 0.2 and math.abs(self.Vel.X) < 0.2 then
		self.PinStrength = 99999;
	end --If vel == 0
	
	if self.LTimer.ElapsedSimTimeMS < 5000 and self.BTimer:IsPastSimMS(250) then
		if self.LTimer.ElapsedSimTimeMS < 2000 and self.BTimer:IsPastSimMS(500) then
			self.BTimer:Reset();
		end
		for i=-3.14, 3.14, 0.157 do
			local particle = CreateMOPixel("ClearEye Designator Blip", "ClearEye.rte")
			local hypot = 500;
			if self.LTimer.ElapsedSimTimeMS > 3000 then
				hypot = hypot * ((self.LTimer.ElapsedSimTimeMS - 5000) / -2000)
			end
			particle.Pos.Y = self.Pos.Y + hypot * math.sin(i + (self.LTimer.ElapsedSimTimeMS / 3000));
			particle.Pos.X = self.Pos.X + hypot * math.cos(i + (self.LTimer.ElapsedSimTimeMS / 3000));
			MovableMan:AddParticle(particle)
		end -- For loop
	end -- less than 3500
	
	if self.LTimer:IsPastSimMS(3000) then
		self.GetsHitByMOs = true;
		Lasers(self.Pos.X + RangeRand(-2, 2), self);
		self:EnableEmission(true);
	end -- Timer 3000
	
	if self.LTimer:IsPastSimMS(5000) then
		local laseroffset = math.cos( (self.LTimer.ElapsedSimTimeMS - 5000)/800 ) * ((self.LTimer.ElapsedSimTimeMS - 14500)/-9500);
		Lasers(self.Pos.X + 500 * laseroffset , self);
		Lasers(self.Pos.X - 500 * laseroffset , self);
		Lasers(self.Pos.X + 200 * laseroffset , self);
		Lasers(self.Pos.X - 200 * laseroffset , self);

	end -- Timer 5000
	
	if self.LTimer:IsPastSimMS(7500) then
	    for particle in MovableMan.Particles do
	    	--print (particle.ID);
			if math.abs(particle.Pos.X - self.Pos.X) < 250 and math.abs(particle.Pos.Y - self.Pos.Y) < 250 and particle.ID ~= self.ID then
				particle.Vel.Y = particle.Vel.Y - 0.5;
			end
	    end --For loop
	    
	    for actor in MovableMan.Actors do
			if math.abs(actor.Pos.X - self.Pos.X) < 350 and math.abs(actor.Pos.Y - self.Pos.Y) < 350 then
				actor.Vel.Y = actor.Vel.Y - 0.35;
			end
	    end --For loop
	    
	    
		local particle = CreateMOPixel("ClearEye Overdrive Laser Pulse", "ClearEye.rte")
		local theta = RangeRand(-3.14, 3.14);
		local hypot = RangeRand(200, 35);
		particle.Pos.Y = self.Pos.Y + hypot * math.sin(theta);
		particle.Pos.X = self.Pos.X + hypot * math.cos(theta);
		MovableMan:AddParticle(particle)
	    
	end --Timer 7500
	
	if self.LTimer:IsPastSimMS(10500) then
		local particle = CreateMOPixel("ClearEye Overdrive Flash", "ClearEye.rte")
		local theta = RangeRand(-3.14, 3.14);
		local hypot = RangeRand(150, 35);
		particle.Pos.Y = self.Pos.Y + hypot * math.sin(theta);
		particle.Pos.X = self.Pos.X + hypot * math.cos(theta);
		MovableMan:AddParticle(particle)
	end --Timer 10500
	
	if self.LTimer:IsPastSimMS(13000) then
		local particle = CreateMOPixel("ClearEye Overdrive Flash", "ClearEye.rte")
		local theta = RangeRand(-3.14, 3.14);
		local hypot = RangeRand(150, 35);
		particle.Pos.Y = self.Pos.Y + hypot * math.sin(theta);
		particle.Pos.X = self.Pos.X + hypot * math.cos(theta);
		MovableMan:AddParticle(particle)
	end --Timer 13000
	
	if self.LTimer:IsPastSimMS(14500) then
		
		
		local particle = CreateAEmitter("Final Overdrive Laser", "ClearEye.rte")
		particle.Pos.Y = 0;
		particle.Vel.Y = 150;
		particle.Pos.X = self.Pos.X;
		MovableMan:AddParticle(particle)
		
		self:GibThis();
	end -- Timer 14500
end 